PAT 1007 Maximum Subsequence Sum

PAT (Advanced Level) Practice 1007 Maximum Subsequence Sum (25 分)

连续最大子序列和 动态规划


题目分析

Given a sequence of K integers { N1​, N2​, …, NK​ }. A continuous subsequence is defined to be { Ni​, Ni+1​, …, Nj​ } where 1≤i≤j≤K. The Maximum Subsequence is the continuous subsequence which has the largest sum of its elements. For example, given sequence { -2, 11, -4, 13, -5, -2 }, its maximum subsequence is { 11, -4, 13 } with the largest sum being 20.
Input Specification:
Each input file contains one test case. Each case occupies two lines. The first line contains a positive integer K (≤10000). The second line contains K numbers, separated by a space.

Output Specification:
For each test case, output in one line the largest sum, together with the first and the last numbers of the maximum subsequence. The numbers must be separated by one space, but there must be no extra space at the end of a line. In case that the maximum subsequence is not unique, output the one with the smallest indices i and j (as shown by the sample case). If all the K numbers are negative, then its maximum sum is defined to be 0, and you are supposed to output the first and the last numbers of the whole sequence.
Sample Input:

10
-10 1 2 3 4 -5 -23 3 7 -21

Sample Output:

10 1 4


算法分析:

依据动态规划的思想找到子问题的最优解,从而找到全局的最优解:

这个问题如果暴力来做,枚举左端点和右端点(即枚举 i , j)需要 O(n的平方)复杂度,而计算 A [i] +A[1]+…+ A [n]需要 O(n)的复杂度,因此总复杂度为 O(n^3)。
下面介绍动态规划的做法,复杂度为O(n),会发现其实左端点的枚举是没有必要的步骤1:令状态 dp [ i ]表示以 A[i]作为末尾的连续序列的最大和(这里是说 A[i]必须作发连续序列的末尾)以样例为例:序列﹣2 11 -4 13 -5 -2,下标分别记为0,1,2,3.4,5,那么

dp [0]=-2,
dp [1]=11,
dp [2]=7(11+(4)=7),
dp [3]=20(11+(-4)+13=20),
dp [4]=15(因为由 dp 数组的含义, A [4]=-5必须作为连续序列的结尾,于是最大和就是11+(4)+13+(-5)=15,而不是20),
dp [5]=13(11+(-4)+13+(-5)+(-2)=13)。

通过设置这么一个 dp 数组,要求的最大和其实就是 dp [0], dp [1],…, dp [ n -1]中的最大值(因为到底以哪个元素结尾未知),下面想办法求解dp数组。
步骤2:作如下考虑:因为 dp [i]要求是必须以 A [i]结尾的连续序列,那么只有两种情况:

①这个最大和的连续序列只有一个元素,即以 A [i]开始,以 A [i]结尾。
②这个最大和的连续序列有多个元素,即从前面某处 A[p]开始( p<i ),一直到 A [i]结尾。对第一种情况,最大和就是A[i]本身。

对第二种情况,最大和是 dp [i -1]+A[i],即 A [p]+…+ A [i -1]+ A[i]= dp[i -1]+A[i]。由于只有这两种情况,于是得到状态转移方程:
dp[i]=max{A[i],dp[i-1]+A[i]}
这个式子只和 i 与之前的元素有关,且边界为 dp [0]= A[0] ;由此从小到大枚举 i ,即可得到整个 dp 数组。接着输出 dp [0], dp [i],…, dp [n-1]中的最大值即为最大连续子序列的和。


源代码

#include<iostream>
#include<algorithm>
using namespace std;
const int maxn = 10000;
int n, A[maxn], dp[maxn], len[maxn];
int main() {
	scanf_s("%d", &n);
	bool AllNegative = true;
	for (int i = 0; i < n; i++) {
		int num;
		scanf_s("%d", &num);
		A[i] = num;
		if (num >= 0) {
			AllNegative = false;
		}
	}
	if (AllNegative) {
		printf("%d %d %d", 0, A[0], A[n - 1]);
		return 0;
	}

	dp[0] = A[0];
	len[0] = 1;
	for (int i = 1; i < n; i++) {
		if (A[i] > dp[i - 1] + A[i]) {
			dp[i] = A[i];
			len[i] = 1;
		}
		else {
			dp[i] = dp[i - 1] + A[i];
			len[i] = len[i - 1] + 1;
		}
	}
	int length = 0, k = 0, end = 0;
	for (int i = 0; i < n; i++) {
		if (dp[i] > k) {
			k = dp[i];
			length = len[i];
			end = i;
		}
	}
	if (k == 0) {
		printf("%d %d %d", 0, 0, 0);
	}
	else {
		printf("%d %d %d", k, A[end - length + 1], A[end]);
	}
	return 0;
}
  • 0
    点赞
  • 0
    收藏
    觉得还不错? 一键收藏
  • 0
    评论

“相关推荐”对你有帮助么?

  • 非常没帮助
  • 没帮助
  • 一般
  • 有帮助
  • 非常有帮助
提交
评论
添加红包

请填写红包祝福语或标题

红包个数最小为10个

红包金额最低5元

当前余额3.43前往充值 >
需支付:10.00
成就一亿技术人!
领取后你会自动成为博主和红包主的粉丝 规则
hope_wisdom
发出的红包
实付
使用余额支付
点击重新获取
扫码支付
钱包余额 0

抵扣说明:

1.余额是钱包充值的虚拟货币,按照1:1的比例进行支付金额的抵扣。
2.余额无法直接购买下载,可以购买VIP、付费专栏及课程。

余额充值